import Vue from 'vue'
import axios from 'axios'
import ElementUI from 'element-ui'
import 'element-ui/lib/theme-chalk/index.css'
import App from './App'
import router from './router'
import store from './store'
import io from 'socket.io-client';
import VueSocketio from 'vue-socket.io'
import ECharts from 'vue-echarts/components/ECharts'
import 'echarts/lib/chart/bar'
import 'echarts/lib/chart/line'
import 'echarts/lib/chart/scatter'
import 'echarts/lib/component/tooltip'
import 'echarts/lib/component/polar'
import 'echarts/lib/chart/heatmap'
import 'echarts/lib/component/visualMapContinuous'
if (!process.env.IS_WEB) Vue.use(require('vue-electron'))
Vue.http = Vue.prototype.$http = axios
Vue.config.productionTip = false
const SocketInstance = io.connect('http://localhost:3001', {
    query: {
        token: window.localStorage.getItem('auth')
    }
});

Vue.use(new VueSocketio({
   // debug: true,
    connection: SocketInstance,
    vuex: {
        store,
        actionPrefix: 'SOCKET_',
        mutationPrefix: 'SOCKET_'
    },
}),store);
//Vue.use(VueSocketio, 'http://localhost:3000', store)
Vue.use(ElementUI)
Vue.component('chart', ECharts)
/* eslint-disable no-new */
new Vue({
  components: { App },
  router,
  store,
  template: '<App/>'
}).$mount('#app')
